/*
 * Copyright (c) 2024 ShinGeTsu Meter.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */
#pragma once

#define I2C0_SPEED_kHz 1800    // 2000kHzぐらいが限界値
#define I2C1_SPEED_kHz 360     // LCDは最大400kHz

// I2C0 -> ADC, メーター用DAC
#define I2C0_SDA_PIN 16
#define I2C0_SCL_PIN 17

// I2C1 -> LCD, TA用DAC
#define I2C1_SDA_PIN 18
#define I2C1_SCL_PIN 19

// I2Cアドレス
#define ADDR_MCP4726 0x60
#define ADDR_LCD     0x3e
#define ADDR_ADS1015 0x48

// DAC
#define DAC_MAX_VALUE 4095.0f
#define DAC_MIN_VALUE 0.0f
#define DAC_WAIT_US   7    // MCP4726の設定時間:6μs + 1μs

// ADC
#define ABERAGING_NUM 16    // 平均値を取得する際のサンプリング数

void    initI2C();
float   readRefV(bool averaging);
float   readDacV(bool averaging);
float   readPcV(bool averaging);
float   readOutputV(bool averaging);
int16_t setMeterDac(float value);
int16_t setTaDac(int16_t value);
void    lcdPrint(uint8_t row, char *mess);
